//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Programa_teste.h"
#include "ThreadMonitorIcbox.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#pragma hdrstop
//---------------------------------------------------------------------------

extern "C" __stdcall __declspec(dllimport) int testCom(char * retBuffer,AnsiString arg);
extern "C" __stdcall __declspec(dllimport) int openSetupDialog(char* retBuffer);
extern "C" __stdcall __declspec(dllimport) int openCom(char * retBuffer,AnsiString arg);
extern "C" __stdcall __declspec(dllimport) bool closeCom(void);
extern "C" __stdcall __declspec(dllimport) bool isConnected(void);
extern "C" __stdcall __declspec(dllimport) bool getOnHook(void);
extern "C" __stdcall __declspec(dllimport) int getVersionInfo(char * retBuffer);
extern "C" __stdcall __declspec(dllimport) int getRXLevel(char * retBuffer);
extern "C" __stdcall __declspec(dllimport) bool setRXLevel(int arg);
extern "C" __stdcall __declspec(dllimport) int getEvent(char* retBuffer,int timeOut);
extern "C" __stdcall __declspec(dllimport) void finalize(void);
extern "C" __stdcall __declspec(dllimport) void initialize(AnsiString arg);
extern "C" __stdcall __declspec(dllimport) int getRXMode(char * retBuffer);
extern "C" __stdcall __declspec(dllimport) bool setRXMode(int arg);
extern "C" __stdcall __declspec(dllexport) int getId(char * retBuffer);
extern "C" __stdcall __declspec(dllexport) bool setId(AnsiString arg);
extern "C" __stdcall __declspec(dllimport) bool dialNumber(AnsiString arg);
extern "C" __stdcall __declspec(dllimport) bool checkConnectionStatus();

TForm1 *Form1;
 bool modoProgramacao;
void setgroupBox(bool arg){
        Form1->GroupBox1->Visible = arg;
        Form1->GroupBox2->Visible = arg;
        Form1->GroupBox3->Visible = arg;
        Form1->GroupBox4->Visible = arg;
        Form1->GroupBox5->Visible = arg;
        Form1->GroupBox6->Visible = arg;
        Form1->GroupBox8->Visible = arg;
        Form1->GroupBox9->Visible = arg;
        Form1->GroupBox10->Visible = arg;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   AnsiString porta = "COM6";
   ThreadMonitorICBox *ThreadIcBox = new ThreadMonitorICBox(false);

       setgroupBox(false);
       porta = Edit1->Text;
       initialize(Edit1->Text);

       Button2->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
       int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));

   sizeRet = openSetupDialog(_data);
    AnsiString retorno ;
   if(sizeRet > 0 ){
     retorno = (String(_data)).Trim();
   }

  Edit1->Text = retorno;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
       int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));

    AnsiString mensagem = "";
    AnsiString porta = "";
    porta = Trim(Edit1->Text);
  if(isConnected()){
     if(closeCom()){
        Form1->Button2->Caption = "Conectar";
        Form1->Button1->Enabled = true;
                 setgroupBox(false);

     }
   } else {
    if(porta == ""){
      ShowMessage("Selecione uma porta ou digite uma porta vlida");
      return;
     }
     sizeRet =  openCom(_data, porta);
     if(sizeRet >0){
       mensagem = (String(_data)).Trim();
     }
    if(mensagem == ""){
         Form1->Button2->Caption = "Desconectar";
         Form1->Button1->Enabled = false;
        setgroupBox(true);

    }  else {
     ShowMessage(mensagem);
    }
   }

}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
      int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));

   sizeRet = testCom(_data, Edit2->Text+ "\r\n");

   if(sizeRet >0){
    value = (String(_data)).Trim();
   }

   Edit3->Text =  value ;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  if(isConnected()){
    if(getOnHook()){
    Label1->Caption = "No gancho.";
     } else {
     Label1->Caption = "Fora do gancho.";
    }
  } else {
  ShowMessage("No conectado ao ic-box");
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if(isConnected()){
     Label2->Caption = "Conectado";
  } else {
     Label2->Caption = "Desconectado";
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }

   AnsiString level =  Edit4->Text;

   int intLevel = StrToInt(level);

   if((intLevel < 1 )||(intLevel > 8)){
       ShowMessage("O valor de nvel de rx deve estar dentro do intervalo 1 e 8");
       return;
   } else {
     if (setRXLevel(intLevel)){
       ShowMessage("Valor "+IntToStr(intLevel)+" gravado com sucesso");
       Label4->Caption = IntToStr(intLevel);
     }
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
   int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));

  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }

   sizeRet = getRXLevel(_data);
   if (sizeRet >0 ){
     value = (String(_data)).Trim();
   }
    Label4->Caption = value;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{

   int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));
   int intValue = 0;

  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }

   sizeRet = getRXMode(_data);
   if(sizeRet > 0){
   value = (String(_data)).Trim();
   }

    intValue = StrToInt(value.SubString(0,1));

   if( 0 > intValue <4){
      switch(intValue){

       case  1:  Label5->Caption = "1: Automtico";
           break;
       case  2: Label5->Caption = "2: DTMF";
           break;
       case  3:  Label5->Caption = "3: FSK";
           break;
       }

   } else {
   ShowMessage("valor lido fora do esperado:"+intValue);
   }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }
 AnsiString mode =  Edit5->Text;

   int intMode = StrToInt(mode);

   if((intMode < 1 )||(intMode > 3)){
       ShowMessage("O valor de modo rx deve estar dentro do intervalo 1 e 3");
       return;
   } else {
     if (setRXMode(intMode)){
        ShowMessage("Modo "+IntToStr(intMode)+" gravado com sucesso");
        Label5->Caption = IntToStr(intMode);
     }
     }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
char _data[100];

   int sizeRet = 0;
   memset(&_data[0], 0, sizeof(_data));
   String valor = "";
try {
  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }
  sizeRet = getVersionInfo(_data);
  if (sizeRet  >0){
    valor = String(_data);

  }

  Label3->Caption = valor;
 }
      catch (Exception& e)
      {
         ShowMessage("Exception cought: " + e.Message + e.ClassName()+ "\n");
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  int f =0;
  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }
  AnsiString valorEdit =  Edit6->Text.Trim();
  int cont = valorEdit.Length();
  if  (cont > 0){
    for(f=0; f< cont; f++){
       char caracter[1] ;
       int teste = 0;
       AnsiString  parte = valorEdit.SubString(f+1,1);
       strcpy(caracter, parte.c_str());
       cont = valorEdit.Length();
       teste = caracter[0];
       if((teste < 48)||(teste > 57)){
          if((teste != 80)&&(teste != 112)){
             ShowMessage("O campo possui caractere(s) invlido(s)");
             return;
           }
       }
     }
  }
   if  (cont > 19){
    ShowMessage("O limite mximo so de 20 digitos para discagem");
          return;

   }

   if(dialNumber(valorEdit)){
     ShowMessage("Nmero discado com sucesso");
   }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
      //Button2->Enabled = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
   finalize();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
   if(checkConnectionStatus()){
     Label11->Caption = "Canal de comunicao ativo.";
   } else {
    Label11->Caption = "Problemas na comunicao.";
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{

  modoProgramacao =  CheckBox1->Checked;
}
//---------------------------------------------------------------------------
bool __fastcall getModoProgramacao(void){
 return modoProgramacao;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
{
   int sizeRet = 0;
   String value = "";
   char _data[100];
   memset(&_data[0], 0, sizeof(_data));

  if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }

  sizeRet = getId(_data);
    if (sizeRet >0 ){
      value = (String(_data)).Trim();
    }


   if(value.Length() == 3){
        Label10->Caption = value;
   } else {
   ShowMessage("valor lido fora do esperado:"+value);
   }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
 if(!isConnected()){
        ShowMessage("No conectado ao ic-box");
        return;
  }
 AnsiString id =  Edit7->Text;

   if(id.Length() == 3){
     if (setId(id)){
        ShowMessage("Id "+id+" gravado com sucesso");
        Label10->Caption = id;
     } else {
             ShowMessage("Erro ao gravar Id "+id+". \r\n use valores entre 001 e 999");
     }

   } else {
       ShowMessage("Id Invlido: "+id+" \r\n use valores entre 001 e 999");
     }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
{
//do nothing

}



