//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "Programa_teste.cpp"
#include "ThreadMonitorIcbox.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall ThreadMonitorICBox::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
  int gCounter;
  
__fastcall ThreadMonitorICBox::ThreadMonitorICBox(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ThreadMonitorICBox::Execute()
{
while(true)
  {
  Synchronize(CheckSerialIcBox);
    Synchronize(CheckGancho);
  Sleep(1000);
  }

}
//---------------------------------------------------------------------------
void __fastcall ThreadMonitorICBox::CheckSerialIcBox()
{
   char _data[100];
   int sizeRet = 0;
   memset(&_data[0], 0, sizeof(_data));

   AnsiString numero = "";
   AnsiString tipoLigacao = "";
   AnsiString tipoEvento = "";
   AnsiString data = "";
   AnsiString hora = "";
   AnsiString Id = "";

 if(!isConnected()){
 return;
 }

 if(getModoProgramacao()){
  return;
 }
 AnsiString retorno = "";
  sizeRet = getEvent(_data,300);

  if (sizeRet > 0){
    retorno = (String(_data));//.Trim();
  }



 if(retorno.Length() > 20){

    numero=  retorno.SubString(0,22).Trim();
    Id =retorno.SubString(24,3);
    tipoLigacao = retorno.SubString(23,1);
    tipoEvento = retorno.SubString(39,1);
    data =Date().DateString();
    hora = Time().TimeString();

   ShowMessage("String IC-BOX \r\n"+retorno + "\r\n"+
     "Nmero       : "+numero+" \r\n"+
     "Id icbox      : "+Id+" \r\n"+ 
     "Tipo ligacao: "+tipoLigacao+" \r\n"+
     "Tipo evento : "+tipoEvento+" \r\n"+
     "Data            : "+ data+ "\r\n"+
     "Hora            : " + hora+ "\r\n");



 }
}
//--------------------------------------------------------------------------
void __fastcall ThreadMonitorICBox::CheckGancho()
{

 if(!isConnected()){
 return;
 }

 if(getModoProgramacao()){
  return;
 }
 bool nogancho = getOnHook();

 
}